NXWidgets: NXWidgets::CCheckBox Class Reference

NXWidgets 1.19

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
NXWidgets::CCheckBox Class Reference

`#include <ccheckbox.hxx>`

Inheritance diagram for NXWidgets::CCheckBox:

## Public Types
enum | CheckBoxState { CHECK_BOX_STATE_OFF = 0, CHECK_BOX_STATE_ON = 1, CHECK_BOX_STATE_MU = 2 }
Public Types inherited from NXWidgets::CLabel
enum | TextAlignmentHoriz { TEXT_ALIGNMENT_HORIZ_CENTER = 0, TEXT_ALIGNMENT_HORIZ_LEFT = 1, TEXT_ALIGNMENT_HORIZ_RIGHT = 2 }
enum | TextAlignmentVert { TEXT_ALIGNMENT_VERT_CENTER = 0, TEXT_ALIGNMENT_VERT_TOP = 1, TEXT_ALIGNMENT_VERT_BOTTOM = 2 }
Public Types inherited from NXWidgets::CNxWidget
enum | WidgetFlagType { WIDGET_BORDERLESS = 0x0001, WIDGET_DRAGGABLE = 0x0002, WIDGET_PERMEABLE = 0x0004, WIDGET_DOUBLE_CLICKABLE = 0x0008, WIDGET_NO_RAISE_EVENTS = 0x0010 }

## Public Member Functions
| CCheckBox (CWidgetControl *pWidgetControl, nxgl_coord_t x, nxgl_coord_t y, nxgl_coord_t width, nxgl_coord_t height, CWidgetStyle *style=(CWidgetStyle *) NULL)
virtual | ~CCheckBox (void)
virtual const CheckBoxState | getState (void) const
virtual void | setState (CheckBoxState state)
Public Member Functions inherited from NXWidgets::CButton
| CButton (CWidgetControl *pWidgetControl, nxgl_coord_t x, nxgl_coord_t y, nxgl_coord_t width, nxgl_coord_t height, const CNxString &text, CWidgetStyle *style=(CWidgetStyle *) NULL)
virtual | ~CButton ()
Public Member Functions inherited from NXWidgets::CLabel
| CLabel (CWidgetControl *pWidgetControl, nxgl_coord_t x, nxgl_coord_t y, nxgl_coord_t width, nxgl_coord_t height, const CNxString &text, CWidgetStyle *style=(CWidgetStyle *) NULL)
virtual | ~CLabel ()
virtual void | setTextAlignmentHoriz (TextAlignmentHoriz alignment)
virtual void | setTextAlignmentVert (TextAlignmentVert alignment)
const TextAlignmentHoriz | getTextAlignmentHoriz (void) const
const TextAlignmentVert | getTextAlignmentVert (void) const
virtual const CNxString & | getText (void) const
virtual void | setText (const CNxString &text)
virtual void | appendText (const CNxString &text)
virtual void | insertText (const CNxString &text, const int index)
virtual void | highlight (bool highlightOn)
virtual bool | isHighlighted (void) const
virtual void | getPreferredDimensions (CRect &rect) const
virtual void | setFont (CNxFont *font)
virtual bool | isTextChange (void) const
Public Member Functions inherited from NXWidgets::CNxWidget
| CNxWidget (CWidgetControl *pWidgetControl, nxgl_coord_t x, nxgl_coord_t y, nxgl_coord_t width, nxgl_coord_t height, uint32_t flags, FAR const CWidgetStyle *style=(FAR const CWidgetStyle *) NULL)
virtual | ~CNxWidget (void)
nxgl_coord_t | getX (void) const
nxgl_coord_t | getY (void) const
nxgl_coord_t | getRelativeX (void) const
nxgl_coord_t | getRelativeY (void) const
bool | hasFocus (void) const
bool | isDeleted (void) const
bool | isDrawingEnabled (void) const
bool | isHidden (void) const
bool | isEnabled (void) const
bool | isPermeable (void) const
bool | isDoubleClickable (void) const
bool | isBorderless (void) const
bool | isClicked (void) const
bool | isBeingDragged (void) const
nxgl_coord_t | getWidth (void) const
nxgl_coord_t | getHeight (void) const
void | getSize (struct nxgl_size_s &size) const
void | getPos (struct nxgl_point_s &pos) const
CRect | getBoundingBox (void)
void | getBorderSize (WidgetBorderSize &borderSize)
CNxWidget * | getParent (void) const
CNxWidget * | getFocusedWidget (void)
void | getClientRect (CRect &rect) const
void | getRect (CRect &rect) const
CNxFont * | getFont (void) const
nxgl_mxpixel_t | getBackgroundColor (void) const
nxgl_mxpixel_t | getSelectedBackgroundColor (void) const
nxgl_mxpixel_t | getShineEdgeColor (void) const
nxgl_mxpixel_t | getShadowEdgeColor (void) const
nxgl_mxpixel_t | getHighlightColor (void) const
nxgl_mxpixel_t | getDisabledTextColor (void) const
nxgl_mxpixel_t | getEnabledTextColor (void) const
nxgl_mxpixel_t | getSelectedTextColor (void) const
const CWidgetStyle * | getWidgetStyle () const
void | setBorderless (bool isBorderless)
void | setDraggable (bool isDraggable)
void | setPermeable (bool permeable)
void | setDoubleClickable (bool doubleClickable)
void | addWidgetEventHandler (CWidgetEventHandler *eventHandler)
void | removeWidgetEventHandler (CWidgetEventHandler *eventHandler)
int | nWidgetEventHandlers (void) const
void | setRaisesEvents (bool raises)
bool | raisesEvents (void) const
void | disableDrawing (void)
void | enableDrawing (void)
void | setBackgroundColor (nxgl_mxpixel_t color)
void | setSelectedBackgroundColor (nxgl_mxpixel_t color)
void | setShineEdgeColor (nxgl_mxpixel_t color)
void | setShadowEdgeColor (nxgl_mxpixel_t color)
void | setHighlightColor (nxgl_mxpixel_t color)
void | setDisabledTextColor (nxgl_mxpixel_t color)
void | setEnabledTextColor (nxgl_mxpixel_t color)
void | setSelectedTextColor (nxgl_mxpixel_t color)
void | redraw (void)
bool | enable (void)
bool | disable (void)
void | close (void)
bool | show (void)
bool | hide (void)
virtual bool | click (nxgl_coord_t x, nxgl_coord_t y)
virtual bool | isDoubleClick (nxgl_coord_t x, nxgl_coord_t y)
bool | doubleClick (nxgl_coord_t x, nxgl_coord_t y)
bool | release (nxgl_coord_t x, nxgl_coord_t y)
bool | drag (nxgl_coord_t x, nxgl_coord_t y, nxgl_coord_t vX, nxgl_coord_t vY)
bool | keyPress (nxwidget_char_t key)
bool | cursorControl (ECursorControl control)
bool | focus (void)
bool | blur (void)
bool | moveTo (nxgl_coord_t x, nxgl_coord_t y)
bool | resize (nxgl_coord_t width, nxgl_coord_t height)
bool | changeDimensions (nxgl_coord_t x, nxgl_coord_t y, nxgl_coord_t width, nxgl_coord_t height)
void | moveChildToDeleteQueue (CNxWidget *widget)
void | setFocusedWidget (CNxWidget *widget)
virtual bool | checkCollision (nxgl_coord_t x, nxgl_coord_t y) const
virtual bool | checkCollision (nxgl_coord_t x, nxgl_coord_t y, nxgl_coord_t width, nxgl_coord_t height) const
bool | checkCollision (CNxWidget *widget) const
void | addWidget (CNxWidget *widget)
void | insertWidget (CNxWidget *widget)
void | setParent (CNxWidget *parent)
void | destroy (void)
bool | remove (void)
bool | removeChild (CNxWidget *widget)
const CNxWidget * | getChild (int index) const
int | getChildCount (void) const
void | setBorderSize (const WidgetBorderSize &borderSize)

## Protected Member Functions
virtual void | drawContents (CGraphicsPort *port)
virtual void | drawBorder (CGraphicsPort *port)
virtual void | onClick (nxgl_coord_t x, nxgl_coord_t y)
| CCheckBox (const CCheckBox &checkBox)
Protected Member Functions inherited from NXWidgets::CButton
virtual void | drawOutline (CGraphicsPort *port)
void | drawOutline (CGraphicsPort *port, bool useClicked)
void | drawContents (CGraphicsPort *port, bool useClicked)
void | drawBorder (CGraphicsPort *port, bool useClicked)
virtual void | onPreRelease (nxgl_coord_t x, nxgl_coord_t y)
virtual void | onRelease (nxgl_coord_t x, nxgl_coord_t y)
virtual void | onReleaseOutside (nxgl_coord_t x, nxgl_coord_t y)
| CButton (const CButton &button)
Protected Member Functions inherited from NXWidgets::CLabel
virtual void | onResize (nxgl_coord_t width, nxgl_coord_t height)
virtual void | calculateTextPositionVertical (void)
virtual void | calculateTextPositionHorizontal (void)
virtual void | onTextChange (void)
| CLabel (const CLabel &label)
Protected Member Functions inherited from NXWidgets::CNxWidget
void | useWidgetStyle (const CWidgetStyle *style)
void | drawChildren (void)
void | closeChild (CNxWidget *widget)
void | startDragging (nxgl_coord_t x, nxgl_coord_t y)
void | stopDragging (nxgl_coord_t x, nxgl_coord_t y)
| CNxWidget (const CNxWidget &widget)
virtual void | onDoubleClick (nxgl_coord_t x, nxgl_coord_t y)
virtual void | onDrag (nxgl_coord_t x, nxgl_coord_t y, nxgl_coord_t vX, nxgl_coord_t vY)
virtual void | onDragStart (void)
virtual void | onDragStop (void)
virtual void | onFocus (void)
virtual void | onBlur (void)
virtual void | onEnable (void)
virtual void | onDisable (void)

## Protected Attributes
CheckBoxState | m_state
Protected Attributes inherited from NXWidgets::CLabel
CNxString | m_text
struct nxgl_point_s | m_align
TextAlignmentHoriz | m_hAlignment
TextAlignmentVert | m_vAlignment
bool | m_textChange
bool | m_highlighted
Protected Attributes inherited from NXWidgets::CNxWidget
CWidgetControl * | m_widgetControl
CRect | m_rect
nxgl_coord_t | m_grabPointX
nxgl_coord_t | m_grabPointY
nxgl_coord_t | m_newX
nxgl_coord_t | m_newY
CWidgetStyle | m_style
Flags | m_flags
CWidgetEventHandlerList * | m_widgetEventHandlers
struct timespec | m_lastClickTime
nxgl_coord_t | m_lastClickX
nxgl_coord_t | m_lastClickY
int | m_doubleClickBounds
CNxWidget * | m_parent
CNxWidget * | m_focusedChild
TNxArray< CNxWidget * > | m_children
WidgetBorderSize | m_borderSize

## Detailed Description

Class representing a checkbox. Like radio buttons, checkboxes are tri-state - off, on and "mu". The mu state cannot be enabled by a user - it can only be set by the developer.

Definition at line 107 of file ccheckbox.hxx.

## Member Enumeration Documentation

## ◆ CheckBoxState

enum NXWidgets::CCheckBox::CheckBoxState

Enum listing all possible checkbox states.

Enumerator
CHECK_BOX_STATE_OFF | Checkbox is unticked
CHECK_BOX_STATE_ON | Checkbox is ticked
CHECK_BOX_STATE_MU | Checkbox is in the third state

Definition at line 115 of file ccheckbox.hxx.

## Constructor & Destructor Documentation

## ◆ CCheckBox() [1/2]

NXWidgets::CCheckBox::CCheckBox | ( | const CCheckBox & | checkBox | ) |
| inlineprotected

Copy constructor is protected to prevent usage.

Definition at line 158 of file ccheckbox.hxx.

## ◆ CCheckBox() [2/2]

CCheckBox::CCheckBox | ( | CWidgetControl * | pWidgetControl,
|  | nxgl_coord_t | x,
|  | nxgl_coord_t | y,
|  | nxgl_coord_t | width,
|  | nxgl_coord_t | height,
|  | CWidgetStyle * | style = `(CWidgetStyle *)NULL`
| ) |  |

Constructor.

Parameters

  pWidgetControl | The widget control for the display.
  x | The x coordinate of the checkbox, relative to its parent.
  y | The y coordinate of the checkbox, relative to its parent.
  width | The width of the checkbox.
  height | The height of the checkbox.
  style | The style that the widget should use. If this is not specified, the widget will use the values stored in the global g_defaultWidgetStyle object. The widget will copy the properties of the style into its own internal style object.

Definition at line 111 of file ccheckbox.cxx.

## ◆ ~CCheckBox()

virtual NXWidgets::CCheckBox::~CCheckBox | ( | void |  | ) |
| inlinevirtual

Destructor.

Definition at line 184 of file ccheckbox.hxx.

## Member Function Documentation

## ◆ drawBorder()

void CCheckBox::drawBorder | ( | CGraphicsPort * | port | ) |
| protectedvirtual

Draw the area of this widget that falls within the clipping region. Called by the redraw() function to draw all visible regions.

Parameters

  port | The CGraphicsPort to draw to.

See also
  redraw()

Reimplemented from NXWidgets::CButton.

Definition at line 219 of file ccheckbox.cxx.

## ◆ drawContents()

void CCheckBox::drawContents | ( | CGraphicsPort * | port | ) |
| protectedvirtual

Draw the area of this widget that falls within the clipping region. Called by the redraw() function to draw all visible regions.

Parameters

  port | The CGraphicsPort to draw to.

See also
  redraw()

Reimplemented from NXWidgets::CButton.

Definition at line 152 of file ccheckbox.cxx.

## ◆ getState()

virtual const CheckBoxState NXWidgets::CCheckBox::getState | ( | void |  | ) | const
| inlinevirtual

Get the current state of the checkbox.

Returns
  The state of the checkbox.

Definition at line 192 of file ccheckbox.hxx.

## ◆ onClick()

void CCheckBox::onClick | ( | nxgl_coord_t | x,
|  | nxgl_coord_t | y
| ) |  |
| protectedvirtual

Toggles the state of the checkbox.

Parameters

  x | The x coordinate of the click.
  y | The y coordinate of the click.

Reimplemented from NXWidgets::CButton.

Definition at line 255 of file ccheckbox.cxx.

## ◆ setState()

void CCheckBox::setState | ( | CCheckBox::CheckBoxState | state | ) |
| virtual

Set the state of the checkbox.

Parameters

  state | The new checkbox state.

Definition at line 134 of file ccheckbox.cxx.

## Member Data Documentation

## ◆ m_state

CheckBoxState NXWidgets::CCheckBox::m_state
| protected

The state of the checkbox

Definition at line 123 of file ccheckbox.hxx.

The documentation for this class was generated from the following files:

- ccheckbox.hxx
- ccheckbox.cxx